vec4 blur(sampler2D tex,  vec2 newcoord,  float radius) 
{
	vec2 pixel = vec2(1 / viewWidth, 1 / viewHeight) * radius;

	vec3 blur0 = texture2DLod(tex,(newcoord), 0).rgb;
	vec3 blur1 = texture2DLod(tex,(newcoord + pixel * vec2(0, 1)), 0).rgb;
	vec3 blur2 = texture2DLod(tex,(newcoord + pixel * vec2(1, 0)), 0).rgb;
	vec3 blur3 = texture2DLod(tex,(newcoord - pixel * vec2(0, 1)), 0).rgb;
	vec3 blur4 = texture2DLod(tex,(newcoord - pixel * vec2(1, 0)), 0).rgb;
  
	return vec4((blur0 + blur1 + blur2 + blur3 + blur4) / 5, 1.0);
}