// Lens Flare From Open4ES Shader Andoid

// Varying
varying float sunVisibility;
varying vec2 lf1Pos, lf2Pos, lf3Pos, lf4Pos, lf5Pos, lf6Pos, lf7Pos, lf8Pos, lf9Pos, lf10Pos, lf11Pos, lf12Pos, lf13Pos;

// Funtion
float MANHATTAN_DISTANCE(vec2 delta)
{
	return abs(delta.x) + abs(delta.y);
}
 
#define  LENS_FLARE(COLOR, UV, LFPOS, LFSIZE, LFCOLOR) \
				{ \
					vec2 delta = UV - LFPOS; delta.x *= aspectRatio; \
					if (MANHATTAN_DISTANCE(delta) < LFSIZE * 2.0) { \
						float d = max(LFSIZE - sqrt(dot(delta, delta)), 0.0); \
						COLOR += LFCOLOR.rgb * LFCOLOR.a * smoothstep(0.0, LFSIZE, d) * sunVisibility; \
					} \
				}

vec3 lensFlare(vec3 color, vec2 uv) {
	if (sunVisibility <= 0.0) return color;
	
	LENS_FLARE(color, uv, lf1Pos, 0.1, vec4(1.0, 1.0, 0.9, 0.15));
	LENS_FLARE(color, uv, lf2Pos, 0.05, vec4(0.9, 1.0, 0.7, 0.15));
	LENS_FLARE(color, uv, lf3Pos, 0.09, vec4(1.0, 0.7, 0.0, 0.15));
	LENS_FLARE(color, uv, lf4Pos, 0.01, vec4(0.9, 0.1, 0.0, 0.15));
	LENS_FLARE(color, uv, lf5Pos, 0.05, vec4(0.2, 0.06, 0.6, 0.4));
	LENS_FLARE(color, uv, lf6Pos, 0.01, vec4(0.4, 0.03, 1.0, 0.2));
	LENS_FLARE(color, uv, lf7Pos, 0.02, vec4(0.4, 0.9, 0.9, 1.0));
	LENS_FLARE(color, uv, lf8Pos, 0.01, vec4(0.4, 0.4, 1.0, 1.0));
	LENS_FLARE(color, uv, lf9Pos, 0.02, vec4(0.3, 0.4, 1.0, 1.0));
	LENS_FLARE(color, uv, lf10Pos, 0.01, vec4(1.5, 0.85, 0.45, 0.3));
	LENS_FLARE(color, uv, lf11Pos, 0.01, vec4(5.5, 0.8, 0.4, 0.5));
	LENS_FLARE(color, uv, lf12Pos, 0.01, vec4(5.5, 1.0, 1.0, 0.4));
	LENS_FLARE(color, uv, lf13Pos, 0.01, vec4(1.0, 1.0, 1.0, 0.1));
	
	return color;
}