// Motion Blur From Chocapic13 V6

void MotionBlur(inout vec3 color) {
	if (texture2D(gnormal, texcoord).x > 0.00015 || texture2D(gnormal, texcoord).x < 0.00005){
		vec4 currentPosition = vec4(texcoord, texture2D(depthtex0, texcoord).x, 1.0) * 2.0 - 1.0;
	
		vec4 fragposition = gbufferProjectionInverse * currentPosition;
		fragposition = gbufferModelViewInverse * fragposition;
		fragposition /= fragposition.w;
		fragposition.xyz += cameraPosition;
	
		vec4 previousPosition = fragposition;
		previousPosition.xyz -= previousCameraPosition;
		previousPosition = gbufferPreviousModelView * previousPosition;
		previousPosition = gbufferPreviousProjection * previousPosition;
		previousPosition /= previousPosition.w;
	
		vec2 velocity = (currentPosition - previousPosition).st * 0.007 * MOTION_BLUR_AMOUNT;
		velocity = velocity;
		int samples = 1;
		
		vec2 coord = texcoord.st + velocity;
		for (int i = 0; i < 15; ++i, coord += velocity) {
			if (coord.s > 1.0 || coord.t > 1.0 || coord.s < 0.0 || coord.t < 0.0) {
				break;
			}

			if (texture2D(gnormal, coord).x > 0.00015 || texture2D(gnormal, coord).x < 0.00005){
			color += texture2D(gcolor, coord).xyz;
			++samples;
			}
		}	
		color = color/samples+texture2D(composite,texcoord/4.0).rgb*0.4;
	}
}