vec3 dayCloudColor = vec3(1.0);
vec3 nightCloudColor = vec3(0.0, 0.13, 0.25);
vec3 duskCloudColor = vec3(2.0, 1.0, 0.8);
vec3 rainCloudColor = vec3(0.4, 0.45, 0.5);

float ketebalanKabut(float atas, float lebar) {
	return lebar / (atas * atas + lebar);
}

vec3 warnaLangit() {
	vec3 warna = vec3(0.3, 0.5, 1.0);
	warna = mix(warna, vec3(0.3, 0.3, 0.6), sore);
	warna = mix(warna, vec3(0.0, 0.0, 0.1), malam);

	vec3 warnaHujan = mix(vec3(0.4, 0.45, 0.5), vec3(0.1, 0.15, 0.2), malam);
	warna = mix(warna, warnaHujan, hujan);

	return warna;
}

vec3 warnaKabut() {
	vec3 warna = vec3(0.9, 0.95, 1.0);
	warna = mix(warna, vec3(1.0, 0.7, 0.5), sore);
	warna = mix(warna, vec3(0.1, 0.1, 0.2), malam);

	vec3 warnaHujan = mix(vec3(0.7, 0.75, 0.8), vec3(0.1, 0.15, 0.2), malam);
	warna = mix(warna, warnaHujan, hujan);

	return warna;
}

vec3 renderLangit(vec3 pos) {
	float atas = dot(pos, gbufferModelView[1].xyz);
	float kabut = ketebalanKabut(max(atas, 0.0), 0.15);

	vec3 langit = vec3(0.0) + warnaLangit() * exp(-atas * 0.65);

#ifdef GBUFFERS_SKYBASIC
	#ifdef CLOUDS
		float day = saturate(skyColor.r * 2.0);
		float dusk = saturate((fogColor.r - 0.1) - fogColor.b);

		float weather = mix(0.45, 0.0, hujan);
		float noise = smoothstep(weather, CLOUD_QUALITY, fbm(wPos.xz * 0.04, 5));
		float light = smoothstep(weather, 1.0, fbm(wPos.xz * 0.05, 4));
		float cloud = mix(abs(noise * 0.8 + light), 0.0, smoothstep(0.0, far, length(wPos.xz)));
		vec3 color = mix(mix(mix(nightCloudColor, dayCloudColor, day), duskCloudColor, dusk), rainCloudColor, hujan);
		langit = mix(langit, color, cloud);
	#endif
#endif

	langit = mix(langit, warnaKabut(), kabut);
	langit *= exp(min(atas, 0.0)) + warnaLangit() * 0.1;

	return langit;
}