/*
CilokGaming Global Settings
*/

// Extension
	#extension GL_ARB_shader_texture_lod : enable
	#extension GL_EXT_gpu_shader4 : enable

// INFO
	#define CilokG 0 //[0]
	
// Surface
	#define Water_WaveSpeed1	0.1		//[0.01 0.025 0.035 0.05 0.1 0.25 0.35 0.45 0.55 0.65 0.75 0.85 0.95 1.0] //This Controls the first part of the waving water speed, lower numbers means slower waving and Higher makes it faster
	#define Water_WaveSpeed2	0.1		//[0.01 0.025 0.035 0.05 0.1 0.25 0.35 0.45 0.55 0.60 0.65 0.75 0.85 0.95 1.0] //This Controls the Second part of the waving water speed, lower numbers means slower waving and Higher makes it faster

	//#define Dynamic_Water
	#define Dynamic_Weather
	
	//#define Shifting_Rain
	
// Atmospherics
	#define Stars
	//#define FOG
	#define ROUND_SUN_MOON
	#define CLOUDS
	#define CLOUD_QUALITY 0.5 //[1.00 0.63 0.5]
	
// Post-Processing
	#define CHROMATIC_ABERRATION
	#define CHROMATIC_ABERRATION_STRENGTH 1.00 //[1.00 2.00 3.00 4.00 5.00]
	//#define DOF
	#define LENS_FLARE_SHADERS
	//#define MOTION_BLUR
	#define MOTION_BLUR_AMOUNT 0.75 //[0.25 0.50 0.75 1.00 1.25 1.50 1.75 2.00]
	
// Lighting
	#define FILTERED_COLORED_SHADOWS
	#define ENABLED_SHADOW
	#define SHADOW_MAP_BIAS 0.80 //Shadow Bias [0.10 0.15 0.20 0.25 0.30 0.35 0.40 0.45 0.50 0.55 0.60 0.65 0.70 0.75 0.80 0.85 0.90 0.95]
	#define AMBIENT_OCCLUSION
	#define AO_STRENGTH 0.6 //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0]
	
// Waving
	#define WAVING_FLOWERS
	#define WAVING_GRASS
	#define WAVING_LAVA
	#define WAVING_LEAVES
	#define WAVING_POTATOES
	#define WAVING_WATER
	#define WAVING_MELON_STEMS
	#define WAVING_VINES
	#define WAVING_FIRE
	#define WAVING_HAND

// Variable
	#ifdef FOG
		const int GL_LINEAR = 9729;
		const int GL_EXP = 2048;
		uniform int fogMode;
	#endif

// Pipeline
	const float ambientOcclusionLevel = 1.0;
	const float sunPathRotation = -25.0;
	
	const int shadowMapResolution = 4096; //[512 1024 1536 2048 2560 3072 3584 4096 4608 5120 5632 6144 6656 7168 7680 8192]
	const float shadowDistance = 120; //[60 90 120 150 180 210]