/*
CilokGaming Shaders
Newbie Player😅
*/

// Settings
#include "/lib/settings.glsl"

//Fragment Shader
#ifdef FSH

// Uniform
uniform sampler2D gcolor;
uniform sampler2D depthtex1;

uniform int isEyeInWater;

uniform float rainStrength;
uniform float frameTimeCounter;
uniform float near;
uniform float far;

// Varying
varying vec2 texcoord;
varying vec2 lmcoord;

// Optifine Constan
const int RGBA16       = 1;
const int gcolorFormat = RGBA16;
const int noiseTextureResolution = 128;

// Include
#include "/lib/noise.glsl"

// Program 
void main() {
 
	vec4 color = texture2D(gcolor, texcoord.st);
    
	if (isEyeInWater == 1) {
		vec4 UnderWater = texture2D(gcolor, texcoord + mix(vec2(0.0), vec2(snoise(texcoord * 4 + 4.0 * 4.0 + frameTimeCounter * 0.8) * 0.003), saturate(float(frameTimeCounter))));
		gl_FragData[0] = UnderWater;
		return;
	}
	
	/* DRAWBUFFERS:0 */
	gl_FragData[0] = color;
}

#endif

//Vertex Shader
#ifdef VSH

// Varying
varying vec2 texcoord;
varying vec2 lmcoord;

varying vec3 colorWaterMurk;
varying vec3 colorWaterBlue;

// Program
void main() {
    gl_Position = ftransform();
    
    texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
    lmcoord  = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
    
    colorWaterMurk = vec3(0.2f, 0.5f, 0.95f);
	colorWaterBlue = vec3(0.2f, 0.5f, 0.95f);
	colorWaterBlue = mix(colorWaterBlue, vec3(1.0f), vec3(0.5f));
}

#endif