/*
CilokGaming Shaders
Newbie Player😅
*/

// Settings
#include "/lib/settings.glsl"

//Fragment Shader
#ifdef FSH

// Uniform
uniform sampler2D colortex0;
uniform sampler2D depthtex0;

uniform mat4 gbufferProjectionInverse;

uniform float near;
uniform float far;
uniform float viewWidth;
uniform float viewHeight;
	
// Varying
varying vec2 texcoord;

// Common Function
float ditherGradNoise() {
	return fract(52.9829189 * fract(0.06711056 * gl_FragCoord.x + 0.00583715 * gl_FragCoord.y));
}

// Include
#include "/lib/AO.glsl"

// Program
void main() {
	vec3 color = texture2D(colortex0, texcoord).rgb;
	float depth = texture2D(depthtex0, texcoord).x;

	float comp = 1.0 - near / far / far;
	bool sky = depth > comp;

	#ifdef AMBIENT_OCCLUSION
		const float AOStrength = AO_STRENGTH;
		color *= (1.0 - AOStrength) + jaao(texcoord, sky) * AOStrength;
	#endif

	/* DRAWBUFFERS:04 */
	gl_FragData[0] = vec4(color, 1.0);
}

#endif

//Vertex Shader
#ifdef VSH

varying vec2 texcoord;

void main() {
	texcoord = gl_MultiTexCoord0.st;
	gl_Position = ftransform();
}

#endif