/*
CilokGaming Shaders
Newbie Player😅
*/

// Settings
#include "/lib/settings.glsl"

//Fragment Shader
#ifdef FSH

// Uniform
uniform sampler2D lightmap;
uniform sampler2D texture;
uniform vec4 entityColor;

// Varying
in vec2 lmcoord;
in vec2 texcoord;
in vec4 glcolor;

out vec4 colortex0Out;

// Program
void main() {
	vec4 color = texture2D(texture, texcoord) * glcolor;
	color.rgb = mix(color.rgb, entityColor.rgb, entityColor.a);
	color *= texture2D(lightmap, lmcoord);

	/* DRAWBUFFERS:0 */
	colortex0Out = color;
}

#endif

//Vertex Shader
#ifdef VSH

// Varying
varying vec2 lmcoord;
varying vec2 texcoord;
varying vec4 glcolor;

// Program
void main() {
	gl_Position = ftransform();
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
	lmcoord  = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
	glcolor = gl_Color;
}

#endif