/*
CilokGaming Shaders
Newbie Player😅
*/

// Settings
#include "/lib/settings.glsl"

//Fragment Shader
#ifdef FSH

// Uniform
uniform sampler2D lightmap;
uniform sampler2D texture;

// Varying
in float isOre;

in vec2 lmcoord;
in vec2 texcoord;

in vec4 glcolor;

out vec4 colortex0Out;

// Common Function
vec3 Tonemap(vec3 color) {
	color = mix(color, vec3(dot(color, vec3(0.3333))), -1.0 * 1.15 + 1.0);
	color = pow(color, vec3(2.2));
	color = pow(color, vec3(1.1 * 1.0)) * 1.0;
	color *= 2.4 * 1.0;
	color = 1.0 - exp(-color);
	color = pow(color, vec3(0.4545));

	return color;
}

// Program
void main() {
	vec4 color = texture2D(texture, texcoord) * glcolor;
	color *= texture2D(lightmap, lmcoord);
	
	vec3 Ore = texture2D(texture, texcoord).rgb;
	if (isOre == 0.5) if (Ore.r != Ore.b || Ore.r != Ore.g || ((Ore.r + Ore.g + Ore.b) / 3.0) == 1.0) color.rgb = Tonemap(Ore * Ore);

	/* DRAWBUFFERS:0 */
	colortex0Out = color;
}

#endif

//Vertex Shader
#ifdef VSH

// Uniform
uniform float frameTimeCounter;

uniform mat4 gbufferModelView, gbufferModelViewInverse;

// Varying
varying float isOre;
varying vec2 lmcoord;
varying vec2 texcoord;
varying vec4 glcolor;

// Attribute
attribute vec4 mc_Entity;

// Program
void main() {
	gl_Position = ftransform();
	texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
	lmcoord  = (gl_TextureMatrix[1] * gl_MultiTexCoord1).xy;
	glcolor = gl_Color;
	
	isOre = 0.0;
	if (mc_Entity.x == 11204) isOre = 0.5;
	
	vec4 pos = gbufferModelViewInverse * gl_ModelViewMatrix * gl_Vertex;
	
	#ifdef WAVING_HAND
		pos.xy += vec2(0.02 * sin(frameTimeCounter * 1.5), 0.02 * cos(frameTimeCounter * 2.0));
	#endif
	
	gl_Position = gl_ProjectionMatrix * gbufferModelView * pos;
}

#endif