/*
CilokGaming Shaders
Newbie Player😅
*/

// Settings
#include "/lib/settings.glsl"

//Fragment Shader
#ifdef FSH

// Uniform
uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;

uniform float viewHeight;
uniform float viewWidth;
uniform float far;
uniform float frameTimeCounter;

uniform vec3 fogColor;
uniform vec3 skyColor;

// Varying
in vec4 bintang;
in vec3 wPos;

out vec4 colortex0Out;

// Include
#include "/lib/deteksiWaktu.glsl"
#include "/lib/noise.glsl"
#include "/lib/langit.glsl"

void main() {

	vec3 warna;

	if (bintang.a > 0.5) {
#ifdef Stars
		warna = bintang.rgb;
#endif
	} else {
		vec3 ukuranLayar = vec3(gl_FragCoord.xy / vec2(viewWidth, viewHeight), gl_FragCoord.z);
			vec4 posisiMata = gbufferProjectionInverse * vec4(ukuranLayar * 2.0 - 1.0, 1.0);
		posisiMata /= posisiMata.w;
		
		warna = renderLangit(normalize(posisiMata.xyz));
	}
	
	vec3 color = warna;
	
	/* DRAWBUFFERS:0 */
	colortex0Out = vec4(color, 1.0);
}

#endif

//Vertex Shader
#ifdef VSH

uniform mat4 gbufferModelView, gbufferModelViewInverse;

varying vec4 bintang;

varying vec3 wPos;

void main() {
	gl_Position = ftransform();
	
	bintang.rgb = gl_Color.rgb; 
	bintang.a = float(gl_Color.r == gl_Color.g && gl_Color.g == gl_Color.b && gl_Color.r > 0.0);
	
	vec4 pos = gbufferModelViewInverse * gl_ModelViewMatrix * gl_Vertex;
	wPos = pos.xyz;
	pos.y -= length(wPos.xz) * 0.2;
	gl_Position = gl_ProjectionMatrix * gbufferModelView * pos;
}

#endif