/*
CilokGaming Shaders
Newbie Player😅
*/

// Settings
#include "/lib/settings.glsl"

//Fragment Shader
#ifdef FSH

// Adjust Shader Setting

// Uniform
uniform sampler2D texture;

uniform vec3 sunPosition;

uniform mat4 gbufferProjectionInverse;

uniform float viewWidth;
uniform float viewHeight;
uniform float sunAngle;

// Varying
in vec4 color;
in vec2 texcoord;

out vec4 colortex0Out;

// Function
vec3 DrawSun(vec3 pos){
	vec4 ProjDiag = vec4(gbufferProjectionInverse[0].x, gbufferProjectionInverse[1].y, gbufferProjectionInverse[2].zw);
    vec3 p = pos * 2.0 - 1.0;
    vec4 fragpos = ProjDiag * p.xyzz + gbufferProjectionInverse[3];
    return fragpos.xyz / fragpos.w;
}

// Program
void main() {
	vec4 color = texture2D(texture, texcoord) * color;

	vec3 fragposition = DrawSun(vec3(gl_FragCoord.xy / vec2(viewWidth,viewHeight), gl_FragCoord.z));
	float sunFactor = clamp(1.0 - pow(abs(-0.25 + sunAngle) * 4.0, 2.0 / (abs(-0.25 + sunAngle) * 4.0)), 0.0, 1.0);
	float sunVec = max(dot(normalize(fragposition), normalize(sunPosition)), 0.0);
	float sun	= pow(sunVec, 100.0) * 0.5 + smoothstep(0.997, 1.0, sunVec) * 12.0;

	if (sunVec > 0.0) 
	color.rgb *= 0.0;
	color.rgb += sun * mix(vec3(1.0, 0.5, 0.0), vec3(1.0, 0.9, 0.8), sunFactor);
	color.rgb /= 12.0;

	/* DRAWBUFFERS:0 */
	colortex0Out = color;
}

#endif

//Vertex Shader
#ifdef VSH

// Uniform
uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;

// Varying
varying vec4 color;

varying vec2 texcoord;

// Program
void main() {
	texcoord = gl_MultiTexCoord0.st;
	color = gl_Color;

	vec4 position = gbufferModelViewInverse * gl_ModelViewMatrix * gl_Vertex;

	gl_Position = gl_ProjectionMatrix * gbufferModelView * position;
}

#endif