/*
CilokGaming Shaders
Newbie Player😅
*/

// Settings
#include "/lib/settings.glsl"

//Fragment Shader
#ifdef FSH

// Uniform
uniform sampler2D texture;

uniform float rainStrength;

// Varying
in vec4 color;
in vec4 texcoord;

out vec4 colortex0Out;

// Program
void main() {

	vec4 color = (texture2D(texture, texcoord.st).rgb, texture2D(texture, texcoord.st).a * 1.0f) * color;
	color.rgb *= mix(vec3(1.0), vec3(0.128f, 0.128f, 0.128f) * 0.3f, rainStrength);
	
	/* DRAWBUFFERS:0 */
	colortex0Out = color;
}

#endif

//Vertex Shader
#ifdef VSH

// Uniform
uniform vec3 cameraPosition;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferModelView;

uniform float frameTimeCounter;

// Varying
varying vec4 color;
varying vec4 texcoord;

varying vec3 fragpos;

// Program
void main() {	

#ifdef Shifting_Rain
	vec4 position = gbufferModelViewInverse * gl_ModelViewMatrix * gl_Vertex;
		vec3 worldpos = position.xyz + cameraPosition;
		bool istopv = worldpos.y > cameraPosition.y + 5.0;
		
	if (!istopv) position.xz += vec2(2.3, 1.0) + sin(frameTimeCounter) * sin(frameTimeCounter) * sin(frameTimeCounter) * vec2(2.1, 0.6);
	position.xz -= (vec2(3.0, 1.0) + sin(frameTimeCounter) * sin(frameTimeCounter) * sin(frameTimeCounter) * vec2(2.1, 0.6)) * 0.25;
	gl_Position = gl_ProjectionMatrix * gbufferModelView * position;
#else
	gl_Position = ftransform();
#endif
	
	color = gl_Color;
	texcoord = gl_TextureMatrix[0] * gl_MultiTexCoord0;
}

#endif